---
title: '<xsl:number>'
slug: Web/XSLT/Element/number
tags:
  - Element
  - Number
  - Reference
  - XSLT
---
<p>{{ XsltRef() }}</p>

<p>The <code>&lt;xsl:number&gt;</code> element counts things sequentially. It can also be used to quickly format a number.</p>

<h3 id="Syntax">Syntax</h3>

<pre>&lt;xsl:number
	count=EXPRESSION
	level="single" | "multiple" | "any"
	from=EXPRESSION
	value=EXPRESSION
	format=FORMAT-STRING
	lang=XML:LANG-CODE
	letter-value="alphabetic" | "traditional"
	grouping-separator=CHARACTER
	grouping-size=NUMBER  /&gt;</pre>

<h3 id="Required_Attributes">Required Attributes</h3>

<p>None.</p>

<h3 id="Optional_Attributes">Optional Attributes</h3>

<dl>
 <dt><code>count</code></dt>
 <dd>Specifies what in the source tree should be numbered sequentially. It uses an XPath expression.</dd>
</dl>

<dl>
 <dt><code>level</code></dt>
 <dd>Defines how levels of the source tree should be considered in generating sequential numbers. It has three valid values: <code>single</code>, <code>multiple</code>, and <code>any</code>. The default value is <code>single</code>:</dd>
</dl>

<dl>
 <dd>
 <dl>
  <dt><code>single</code></dt>
  <dd>Numbers sibling nodes sequentially, as in the items in a list. The processor goes to the first node in the <a href="en/Transforming_XML_with_XSLT/Mozilla_XSLT%2f%2fXPath_Reference/Axes/ancestor-or-self"><code>ancestor-or-self</code></a> axis that matches the <code>count</code> attribute and then counts that node plus all its preceding siblings (stopping when it reaches a match to the <code>from</code> attribute, if there is one) that also match the <code>count</code> attribute.If no match is found, the sequence will be an empty list.</dd>
 </dl>
 </dd>
</dl>

<dl>
 <dd>
 <dl>
  <dt><code>multiple</code></dt>
  <dd>Numbers nodes as a composite sequence that reflects the hierarchic position of the node, e.g. 1.2.2.5. (The nested format can be specified with the <code>format</code> attribute, e.g. A.1.1). The processor looks at all <a href="en/Transforming_XML_with_XSLT/Mozilla_XSLT%2f%2fXPath_Reference/Axes/ancestor"><code>ancestors</code></a> of the current node and the current node itself, stopping when it reaches a match for the <code>from</code> attribute, if there is one. For each node in this list that matches the <code>count</code> attribute, the processor counts how many preceding matching siblings it has, and adds one for the node itself. If no match is found, the sequence will be an empty list.</dd>
 </dl>
 </dd>
</dl>

<dl>
 <dd>
 <dl>
  <dt><code>any</code> (Not supported at this time.)</dt>
  <dd>Numbers all matching nodes, regardless of level, sequentially. The <a href="en/Transforming_XML_with_XSLT/Mozilla_XSLT%2f%2fXPath_Reference/Axes/ancestor"><code>ancestor</code></a>, <a href="en/Transforming_XML_with_XSLT/Mozilla_XSLT%2f%2fXPath_Reference/Axes/self"><code>self</code></a>, and <a href="en/Transforming_XML_with_XSLT/Mozilla_XSLT%2f%2fXPath_Reference/Axes/preceding"><code>preceding</code></a> axes are all considered. The processor starts at the current node and proceeds in reverse document order, stopping if it reaches a match to any <code>from</code> attribute. If no match to the <code>count</code> attribute is found, the sequence will be an empty list. This level is not supported at this time.</dd>
 </dl>
 </dd>
</dl>

<dl>
 <dt>from</dt>
 <dd>Specifies where the numbering should start or start over. The sequence begins with the first descendant of the node that matches the <code>from</code> attribute.</dd>
</dl>

<dl>
 <dt>value</dt>
 <dd>Applies a given format to a number. This is a quick way to format a user-supplied number (as opposed to a node sequence number) in any of the standard <code>&lt;xsl:number&gt;</code> formats.</dd>
</dl>

<dl>
 <dt>format</dt>
 <dd>Defines the format of the generated number:</dd>
</dl>

<dl>
 <dd>
 <dl>
  <dt>format="1"</dt>
  <dd>1 2 3 . . . (This is the only format supported at this time)</dd>
 </dl>
 </dd>
</dl>

<dl>
 <dd>
 <dl>
  <dt>format="01"</dt>
  <dd>01 02 03 . . . 09 10 11 . . .</dd>
 </dl>
 </dd>
</dl>

<dl>
 <dd>
 <dl>
  <dt>format="a"</dt>
  <dd>a b c . . .y z aa ab . . .</dd>
 </dl>
 </dd>
</dl>

<dl>
 <dd>
 <dl>
  <dt>format="A"</dt>
  <dd>A B C . . . Y Z AA AB . . .</dd>
 </dl>
 </dd>
</dl>

<dl>
 <dd>
 <dl>
  <dt>format="i"</dt>
  <dd>i ii iii iv v . . .</dd>
 </dl>
 </dd>
</dl>

<dl>
 <dd>
 <dl>
  <dt>format="I"</dt>
  <dd>I II III IV V . . .</dd>
 </dl>
 </dd>
</dl>

<dl>
 <dt>lang (Not supported at this time.)</dt>
 <dd>Specifies which language's alphabet should be used in letter-based numbering formats.</dd>
</dl>

<dl>
 <dt>letter-value</dt>
 <dd>Disambiguates between numbering sequences that use letters. Some languages have more than one numbering system that use letters. If both systems begin with the same token, ambiguity can arise. This attribute can have the value "<code>alphabetic</code>" or "<code>traditional</code>". The default is "<code>alphabetic</code>".</dd>
</dl>

<dl>
 <dt>grouping-separator</dt>
 <dd>Specifies what character should be used as the group (e.g. thousands) separator. The default is the comma (<code>,</code>).</dd>
</dl>

<dl>
 <dt>grouping-size</dt>
 <dd>Indicates the number of digits that make up a numeric group. The default value is "<code>3</code>".</dd>
</dl>

<h3 id="Type">Type</h3>

<p>Instruction, appears within a template.</p>

<h3 id="Defined">Defined</h3>

<p>XSLT, section 7.7</p>

<h3 id="Gecko_support">Gecko support</h3>

<p>Partial support. See comments above.</p>
